/**
*/

import java.util.*;
import java.rmi.*;
import java.rmi.server.*;

import SessionInfo;

/**
*/
public class 
Session extends UnicastRemoteObject implements SessionInterface
{

   NetPlayerInterface player1;
   NetPlayerInterface player2;
   Vector             spectators = new Vector();
   int                sessionId;

   /**
   */
   public
   Session(NetPlayerInterface player, int _sessionId)  throws java.rmi.RemoteException
   {
      player1 = player;
      sessionId = _sessionId;

   }// end of constructor()

   /**
   */
   public void
   startSession(NetPlayerInterface player) throws java.rmi.RemoteException
   {
      player2 = player;
      Message aMessage = new Message(Message.JOIN,player2.getName(),sessionId);
      player1.push(aMessage);
   }

   /**
   */
   public void
   push(Message aMessage) throws java.rmi.RemoteException
   {
     NetPlayerInterface spec;
     String originator = aMessage.getOriginator();
     if(originator!= player1.getOriginatorId()) player1.push(aMessage);
     if(originator!= player2.getOriginatorId()) player2.push(aMessage);

     Enumeration e = spectators.elements();
     
     for(;e.hasMoreElements() ;) 
     {
        spec = (NetPlayerInterface) e.nextElement();

        if(spec!=null) spec.push(aMessage);

     }// end of for
     
   }// end of push()

   /**
   */
   public SessionInfo
   getSessionInfo() throws java.rmi.RemoteException
   {
      SessionInfo ret = null;

      if(player2!=null)
          ret = new SessionInfo(sessionId,player1.getName(),player2.getName());
      else
          ret = new SessionInfo(sessionId,player1.getName());
 
      return ret;

   }// end of getSessionInfo()
   
}// end of Session
